﻿using UnityEngine;
using System.Collections;

public class SoundManager : Singleton<SoundManager> {

    public AudioClip[] speechClips = new AudioClip[20];
    
    public AudioClip crowdChant;
    public AudioClip crowdClap;
    public AudioClip crowdHey;
    
    public AudioClip playerClap;
    public AudioClip playerChant;
    public AudioClip playerHey;
    
    public AudioClip stand;
    public AudioClip alarm;

    void Awake()
    {
    }

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	
	}
    
    Coroutine speechCoro = null;
    
    public void StartSpeech() {
        speechCoro = StartCoroutine(PlayRandomSpeechClips());
    }
    
    IEnumerator PlayRandomSpeechClips()
    {
        AudioSource source = GetComponent<AudioSource>();
        while(true) {
            AudioClip clip = speechClips[Random.Range(0, speechClips.Length)];
            source.clip = clip;
            source.Play();
            
            yield return new WaitForSeconds(clip.length);
        }
    }
    
    public void StopSpeech() {
        if(speechCoro != null)
            StopCoroutine(speechCoro);
    }
}
